#ifndef __I2C_H
#define __I2C_H

#define AT24C01		127
#define AT24C02		255
#define AT24C04		511
#define AT24C08		1023
#define AT24C16		2047
#define AT24C32		4095
#define AT24C64	    8191
#define AT24C128	16383
#define AT24C256	32767  
//ſʹõ24c02ԶEE_TYPEΪAT24C02
#define EE_TYPE AT24C02
					  
uint8_t AT24CXX_ReadOneByte(uint16_t ReadAddr);							//ַָȡһֽ
void AT24CXX_WriteOneByte(uint16_t WriteAddr,uint8_t DataToWrite);		//ַָдһֽ
void AT24CXX_WriteLenByte(uint16_t WriteAddr,uint32_t DataToWrite,uint8_t Len);//ַָʼдָȵ
uint32_t AT24CXX_ReadLenByte(uint16_t ReadAddr,uint8_t Len);					//ַָʼȡָ
void AT24CXX_Write(uint16_t WriteAddr,uint8_t *pBuffer,uint16_t NumToWrite);	//ַָʼдָȵ
void AT24CXX_Read(uint16_t ReadAddr,uint8_t *pBuffer,uint16_t NumToRead);   	//ַָʼָȵ

uint8_t AT24CXX_Check(void);  //
void AT24CXX_Init(void); //ʼIIC


//IO
#define SDA_IN()  {GPIOB->CRL&=0X0FFFFFFF;GPIOB->CRL|=0x80000000;}
#define SDA_OUT() {GPIOB->CRL&=0X0FFFFFFF;GPIOB->CRL|=0x30000000;}

//IO	 
#define IIC_SCL    PBout(6) //SCL
#define IIC_SDA    PBout(7) //SDA	 
#define READ_SDA   PBin(7)  //SDA 

//IICв
void Init_IIC(void);                //ʼIICIO				 
void IIC_Start(void);				//IICʼź
void IIC_Stop(void);	  			//IICֹͣź
void IIC_Send_Byte(uint8_t txd);			//IICһֽ
uint8_t IIC_Read_Byte(unsigned char ack);//IICȡһֽ
uint8_t IIC_Wait_Ack(void); 				//IICȴACKź
void IIC_Ack(void);					//IICACKź
void IIC_NAck(void);				//IICACKź

void IIC_Write_One_Byte(uint8_t daddr,uint8_t addr,uint8_t data);
uint8_t IIC_Read_One_Byte(uint8_t daddr,uint8_t addr);	 
#endif

/*********************************************************************************************************
** End of File
*********************************************************************************************************/
