/*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
**  ſ
**	LCDײ
**  汾Rev1.0 
**  ڣ2011-6-20
**	̳www.openmcu.com	 bbs.openmcu.com
**	Աhttp://shop36995246.taobao.com/   
**  Copyright(c)@	 Dream_etd@163.com	
:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/
//ͷļ
#include "usually.h"
#include "usart.h"
#include "LCD_Drive.h"
#include "hz16.h"
#include "font.h"

static uint16_t DeviceID;			//LCD豸ID

uint16_t TextColor = BLUE , BlackColor = BLACK;

#define LCD_RAM    *(__IO uint16_t *) ((uint32_t)0x60020000)    	//ַĴ
#define LCD_REG    *(__IO uint16_t *) ((uint32_t)0x60000000)	 	//ָĴ
/*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
** : Read_LCDReg
** : Ĵ
** 
**   : Dream
** ա  : 2011620
:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/
uint16_t Read_LCDReg(uint16_t LCD_Reg)
{
	uint16_t temp;

	LCD_REG= LCD_Reg;
 
	temp= LCD_RAM; 
  
  	return temp;		
}
/*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
** : Write_LCDReg
** : LCD дĴ
** 
**   : Dream
** ա  : 2011620
:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/
void Write_LCDReg(uint16_t LCD_Reg,uint16_t LCD_Dat)
{
	LCD_REG= LCD_Reg;	 		//ָĴдָ

	LCD_RAM= LCD_Dat; 			//ݼĴд
}
/*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
** : Read_LCDReg
** : Ĵ
** 
**   : Dream
** ա  : 2011620
:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/
void Write_LCDRam(uint16_t LCD_Dat)
{
	LCD_RAM= LCD_Dat; 			//ݼĴд
}
/*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
** : FSMC_LCDInit
** : LCD FSMCӿ
** 
**   : Dream
** ա  : 2011620
:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/
void FSMC_LCDInit()
{
	FSMC_NORSRAMInitTypeDef  FSMC_NORSRAMInitStructure;	   	//һNORʼṹ
	FSMC_NORSRAMTimingInitTypeDef  p;						//һNORʱʼṹ

  	p.FSMC_AddressSetupTime = 0x00;							//ַʱ䣺0x1
  	p.FSMC_AddressHoldTime = 0x00;							//ַʱ䣺0x00
  	p.FSMC_DataSetupTime = 0x01;							//ݽʱ䣺0x2
  	p.FSMC_BusTurnAroundDuration = 0x00;
  	p.FSMC_CLKDivision = 0x00;
  	p.FSMC_DataLatency = 0x00;
  	p.FSMC_AccessMode = FSMC_AccessMode_B;

  	FSMC_NORSRAMInitStructure.FSMC_Bank = FSMC_Bank1_NORSRAM1;	   	//չNOR BANK ĵ1BANK
  	FSMC_NORSRAMInitStructure.FSMC_DataAddressMux = FSMC_DataAddressMux_Disable;
																	//ʹ߸
  	FSMC_NORSRAMInitStructure.FSMC_MemoryType = FSMC_MemoryType_NOR;//չΪNOR FLASH
  	FSMC_NORSRAMInitStructure.FSMC_MemoryDataWidth = FSMC_MemoryDataWidth_16b;
																	//չ߿Ϊ16λ
  	FSMC_NORSRAMInitStructure.FSMC_BurstAccessMode = FSMC_BurstAccessMode_Disable;
																	//
  	FSMC_NORSRAMInitStructure.FSMC_WaitSignalPolarity = FSMC_WaitSignalPolarity_Low;
																	//
  	FSMC_NORSRAMInitStructure.FSMC_WrapMode = FSMC_WrapMode_Disable;//
  	FSMC_NORSRAMInitStructure.FSMC_WaitSignalActive = FSMC_WaitSignalActive_BeforeWaitState;
  	FSMC_NORSRAMInitStructure.FSMC_WriteOperation = FSMC_WriteOperation_Enable;
  	FSMC_NORSRAMInitStructure.FSMC_WaitSignal = FSMC_WaitSignal_Disable;
  	FSMC_NORSRAMInitStructure.FSMC_ExtendedMode = FSMC_ExtendedMode_Disable;
  	FSMC_NORSRAMInitStructure.FSMC_WriteBurst = FSMC_WriteBurst_Disable;
  	FSMC_NORSRAMInitStructure.FSMC_ReadWriteTimingStruct = &p;	  	
  	FSMC_NORSRAMInitStructure.FSMC_WriteTimingStruct = &p;	  
 
  	FSMC_NORSRAMInit(&FSMC_NORSRAMInitStructure); 							//ָʼṹ
  										
  	FSMC_NORSRAMCmd(FSMC_Bank1_NORSRAM1, ENABLE); 							//ʹFSMC_Bank1_NORSRAM1 ڴ

	RCC_AHBPeriphClockCmd(RCC_AHBPeriph_FSMC, ENABLE);						//ʹFSMCʱ
}
/*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
** : GPIO_LCDInit
** : LCD
** 
**   : Dream
** ա  : 2011620
:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/
void GPIO_LCDInit(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;

	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOD | RCC_APB2Periph_GPIOE | 
							RCC_APB2Periph_AFIO,ENABLE);					//ʹܸ˿ʱ	
	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0 | GPIO_Pin_1 | GPIO_Pin_4 | GPIO_Pin_5 |
                                 GPIO_Pin_7 | GPIO_Pin_8 | GPIO_Pin_9 | GPIO_Pin_10 | 
								 GPIO_Pin_11 | GPIO_Pin_14 | GPIO_Pin_15;
  	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_10MHz;						//50Mhz
  	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;						   	//ù
  	GPIO_Init(GPIOD, &GPIO_InitStructure);

  	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_7 | GPIO_Pin_8 | GPIO_Pin_9 | GPIO_Pin_10 | 
                                GPIO_Pin_11 | GPIO_Pin_12 | GPIO_Pin_13 | GPIO_Pin_14 | 
                                GPIO_Pin_15;
  	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_10MHz;					   //50Mhz
  	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;						   //ù
  	GPIO_Init(GPIOE, &GPIO_InitStructure);
} 
/*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
** : Init_LCD
** : LCDʼ
** 
**   : Dream
** ա  : 2011620
:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/
void Init_LCD(void)
{
	FSMC_LCDInit();									//LCDӦFSMCӿڳʼ
	GPIO_LCDInit();								    //LCDӦIOӿڳʼ
	DeviceID = Read_LCDReg(0x0000);					//ȡLCDIDӦ1289ID0x8999
	printf("DeviceID=0x%x\r\n",DeviceID);			//ʮƷʽLCDȡID
	if(DeviceID == 0x8999)
	{
		//************* Start Initial Sequence **********//
		Write_LCDReg(0x00, 0x0001); // ڲʱ
#if	 	LCD_ID_AM == DsipV_ENABLE
		Write_LCDReg(0x01, 0x3B3F); //: RL=0;REV=1;GD=1;BGR=0;SM=0;TB=1
#elif  	LCD_ID_AM == DsipH_ENABLE
		Write_LCDReg(0x01, 0x7B3F); //:RL=1;REV=1;GD=1;BGR=0;SM=0;TB=1
#endif
		Write_LCDReg(0x02, 0x0600); //set 1 line inversion
		//************* Power control setup ************/
		Write_LCDReg(0x0C, 0x0007); // Adjust VCIX2 output voltage
		Write_LCDReg(0x0D, 0x0006); // Set amplitude magnification of VLCD63
		Write_LCDReg(0x0E, 0x3200); // Set alternating amplitude of VCOM
		Write_LCDReg(0x1E, 0x00BB); // Set VcomH voltage
		Write_LCDReg(0x03, 0x6A64); // Step-up factor/cycle setting
		//************ RAM position control **********/
		Write_LCDReg(0x0F, 0x0000); // Gate scan position start at G0.
		Write_LCDReg(0x44, 0xEF00); // Horizontal RAM address position
		Write_LCDReg(0x45, 0x0000); // Vertical RAM address start position
		Write_LCDReg(0x46, 0x013F); // Vertical RAM address end position
		// ----------- Adjust the Gamma Curve ----------//
		Write_LCDReg(0x30, 0x0000);
		Write_LCDReg(0x31, 0x0706);
		Write_LCDReg(0x32, 0x0206);
		Write_LCDReg(0x33, 0x0300);
		Write_LCDReg(0x34, 0x0002);
		Write_LCDReg(0x35, 0x0000);
		Write_LCDReg(0x36, 0x0707);
		Write_LCDReg(0x37, 0x0200);
		Write_LCDReg(0x3A, 0x0908);
		Write_LCDReg(0x3B, 0x0F0D);
		//************* Special command **************/
		Write_LCDReg(0x28, 0x0006); // Enable test command
		Write_LCDReg(0x2F, 0x12EB); // RAM speed tuning
		Write_LCDReg(0x26, 0x7000); // Internal Bandgap strength
		Write_LCDReg(0x20, 0xB0E3); // Internal Vcom strength
		Write_LCDReg(0x27, 0x0044); // Internal Vcomh/VcomL timing
		Write_LCDReg(0x2E, 0x7E45); // VCOM charge sharing time  
		//************* Turn On display ******************/
		Write_LCDReg(0x10, 0x0000); // Sleep mode off.
		Delay_Ms(3); // Wait 30mS
#if  	LCD_ID_AM == 000
		Write_LCDReg(0x11, 0x6840); //262Kɫ  ˮƽ,ˮƽʹֱַݼ

#elif	LCD_ID_AM == 010
		Write_LCDReg(0x11, 0x6850); //262Kɫ  Entry mode setup. 262K type B, take care on the data bus with 16it only

#elif	LCD_ID_AM == 100
		Write_LCDReg(0x11, 0x6860); //262Kɫ  Entry mode setup. 262K type B, take care on the data bus with 16it only

#elif	LCD_ID_AM == DsipV_ENABLE
		Write_LCDReg(0x11, 0x6870); //262Kɫ  Entry mode setup. 262K type B, take care on the data bus with 16it only

#elif	LCD_ID_AM == DsipH_ENABLE
		Write_LCDReg(0x11, 0x6848); //262Kɫ  Entry mode setup. 262K type B, take care on the data bus with 16it only

#elif	LCD_ID_AM == 011
		Write_LCDReg(0x11, 0x6858); //262Kɫ  Entry mode setup. 262K type B, take care on the data bus with 16it only

#elif	LCD_ID_AM == 101
		Write_LCDReg(0x11, 0x6868); //262Kɫ  Entry mode setup. 262K type B, take care on the data bus with 16it only

#elif	LCD_ID_AM == 111
		Write_LCDReg(0x11, 0x6878); //262Kɫ  Entry mode setup. 262K type B, take care on the data bus with 16it only
#endif
		Write_LCDReg(0x07, 0x0033); // Display ON	*/
	}
	Clear_LCD(BLACK);				
}
/*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
** : Clear_LCD
** : 
**  Color Ϊɫ
**   : Dream
** ա  : 2011620
:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/
void Clear_LCD(uint16_t Color)
{
	uint32_t i;
	Set_LCDCorsor(0,0);								//ʼַ
	LCD_REG = 0x22;									//׼дRAM
	for(i=0;i<LCD_H_MAX*LCD_V_MAX;i++)				//240*320=76800
	{
		LCD_RAM = Color;							//ݼĴд
	}					 
}
/*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
** : Write_LCDRAM_Prepare
** : LCD
** xyΪʾ
**   : Dream
** ա  : 2011620
:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/
void Write_LCDRAM_Prepare(void)
{
	LCD_REG = 0x22;									//׼дRAM
}
/*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
** : Disp_LCDPoint
** : ʾһ
** xyΪַʾλ
**   : Dream
** ա  : 2011620
:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/
void Disp_LCDPoint(uint16_t x,uint16_t y)
{
	Set_LCDCorsor(x,y);
	Write_LCDRAM_Prepare();
	Write_LCDRam(TextColor);
}
/*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
** : Set_LCDWindow
** : LCD
** xyΪʾ
**   : Dream
** ա  : 2011620
:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/
void Set_LCDWindow(uint16_t Xstar, uint16_t Ystar, uint16_t Xend, uint16_t Yend)
{
	//ͼƬʾڴС
	Write_LCDReg(0x44,Xstar|(Xstar+Xend)<<8); //ˮƽGRAMʼַ(ֽΪʼַֽΪַ)
	Write_LCDReg(0x45,Ystar);				  	//ôڵYĿʼλ
	Write_LCDReg(0x46,Ystar+Yend);			//ôڵYĽλ
}
/*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
** : Set_LCDCorsor
** : ʾλ
** xyΪʾ
**   : Dream
** ա  : 2011620
:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/
void Set_LCDCorsor(uint16_t x,uint16_t y)
{
#if	 	LCD_ID_AM == DsipV_ENABLE
	Write_LCDReg(0x4E, x);							//xʼ
	Write_LCDReg(0x4F, y);							//yʼ

#elif  	LCD_ID_AM == DsipH_ENABLE
	Write_LCDReg(0x4E, 239-y);						//xʼ
	Write_LCDReg(0x4F, 319-x);						//yʼ
#endif
}
/*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
** : Disp_LCDChar
** : ʾһַ
** xyΪַʾλ
**   : Dream
** ա  : 2011620
:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/
uint8_t Disp_LCDChar(uint16_t x,uint16_t y,uint8_t star)
{
	uint8_t temp;
	uint16_t i,j;
	uint16_t y0;

	y0 = y;
	for(i=0;i<16;i++)								//ѭ16 ַΪ8*16 16
	{
		Set_LCDCorsor(x,y0);						//ʼλ
		LCD_REG = 0x22;								//׼дRAM
		temp = ASCII_1608[star-0x20][i];			//1608ַ
		for(j=0;j<8;j++)							//ѭ8 ַΪ8*16  8
		{
			if((temp<<j)&0x80)						//ȴλ
			{
				LCD_RAM = TextColor;				//Ϊ1
			}
			else 
			{
				LCD_RAM = BlackColor;				//Ϊ0ûɫ
		    }			
		}
		y0++;										//Yַ1
	}
	return (8);								  		//ַ֮ļ
}
/*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
** : DisplayOneHzChar
** : ʾһָСĺ
**   : Dream
** ա  : 20101206
:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/
uint16_t Disp_LCDHz(uint16_t x,uint16_t y,uint8_t *pucMsk)
{
    uint16_t i,j;
    uint16_t mod[16];                                      /* ǰģ */
    uint16_t *pusMsk;                                      /* ǰַֿ */
    uint16_t y0;
    
    pusMsk = (uint16_t *)pucMsk;
    for(i=0; i<16; i++)                                    /* 浱ǰֵʽģ */
    {
        mod[i] = *pusMsk++;                                /* ȡõǰģֶ*/
        mod[i] = ((mod[i] & 0xff00) >> 8) | ((mod[i] & 0x00ff) << 8);/* ģߵֽڣΪʾ */
                                                           /* Ҫ */
    }
    y0 = y;
    for(i=0; i<16; i++)                                    /* 16 */
    {                                          			   /* ֱʾ */

		Set_LCDCorsor(x,y0);								//ʼλ
		LCD_REG = 0x22;										//׼дGRAM
        for(j=0; j<16; j++)                                /* 16       */
        {
		    if((mod[i] << j)& 0x8000)                     /* ʾģ  */
            { 
			    LCD_RAM= TextColor;
            } 
			else 
			{
                LCD_RAM= BlackColor;                     /* öʽдհ׵*/
			}
        }
        y0++;
    }
    return (16);                                          /* 16λп */
}
/*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
** : Disp_LCDString
** : ʾַ
** xyΪַʾλ   P ַ
**   : Dream
** ա  : 2011620
:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/
void Disp_LCDString(uint16_t x,uint16_t y,uint8_t* p)
{
	uint16_t HzIndex;
	uint8_t Width=0;
	FNT_GB16 *ptGb16 = 0;

    ptGb16 = (FNT_GB16 *)GBHZ_16;  

	while(1)								  	
	{
		x=x+Width;								  	//XַĿ
		if(*p=='\0') break;							//жַǲǽ
		if(*p > 0x80)								//жΪ
		{
			if((x+16)>LCD_H_MAX)
			{
				x=0;
				y=y+16;
				if(y>LCD_V_MAX){y=x=0;Clear_LCD(BlackColor);}
			}
			HzIndex = findHzIndex(p);				//
			Width = Disp_LCDHz(x,y,(uint8_t *)&(ptGb16[HzIndex].Msk[0]));
													//ʾ
		 	p += 2;									//ֵַ2
		}											//жΪǺ
		else
		{
	        if (*p == '\r')                         // 
            { 
			    y = y + 16;                         //ıʾ 
                if(y > LCD_H_MAX)                   //곬 
                {
				    y = 0;
                }
                p++;
                Width = 0;
                continue;
            } 
			else if (*p == '\n')                    //뵽 
            {
			    x = 0;
                p++;
                Width = 0;
                continue;
            } 
			if(x>LCD_H_MAX-8)						//жˮƽǷ񳬳Χ
			{
				x=0;
				y=y+16;
				if(y>LCD_V_MAX-16){y=x=0;Clear_LCD(BlackColor);}
													//жϴֱǷ񳬳Χ
			}			  								  
			Width = Disp_LCDChar(x,y,*p);			//ʾַ
			p++;									//ַַ1
		}
	}								  
}
/*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
** : Disp_LCDBmp
** : ʾͼƬ
** xyΪַʾλ  bmp ͼƬ
**   : Dream
** ա  : 2011620
:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/
void Disp_LCDBmp(uint16_t Xstar,uint16_t Ystar,uint16_t Xend,uint16_t Yend,uint8_t* bmp)
{
	static	uint16_t i=0,j=0;
	uint16_t *bitbmp = (uint16_t *)bmp;

#if	 	LCD_ID_AM == DsipH_ENABLE	 //XY򻥻
	uint16_t XY_Switch;
	XY_Switch = Xend;
	Xend = Yend;
	Yend = XY_Switch;
#endif	 

	//ͼƬʾڴС
	Write_LCDReg(0x44,Xstar|(Xstar+Xend-1)<<8); //ˮƽGRAMʼַ(ֽΪʼַֽΪַ)
	Write_LCDReg(0x45,Ystar);				  	//ôڵYĿʼλ
	Write_LCDReg(0x46,Ystar+Yend-1);			//ôڵYĽλ

#if	 	LCD_ID_AM == DsipV_ENABLE
	Write_LCDReg(0x4E, Xstar);							//xʼ
	Write_LCDReg(0x4F, Ystar);							//yʼ
#elif  	LCD_ID_AM == DsipH_ENABLE
	Write_LCDReg(0x4E, Xstar);						//xʼ
	Write_LCDReg(0x4F, Ystar);						//yʼ
#endif
	
	LCD_REG = 0x22;							  	//׼дݵGRAM
	for(i=0;i<Yend;i++)
	{
		for(j=0;j<Xend;j++)LCD_RAM = *bitbmp++;//Delay_Ms(10);}
	}
	//ظ
	Write_LCDReg(0x44,0|239<<8); 			//ôڵXʼλúͽλ
	Write_LCDReg(0x45,0);				  		//ôڵYĿʼλ
	Write_LCDReg(0x46,319);			  	//ôڵYĽλ
}
/*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
** : Num_power
** : MNη
**   : Dream
** ա  : 20101206
:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/
uint32_t Num_power(uint8_t m,uint8_t n)
{
	u32 result=1;	 
	while(n--)result*=m;    
	return result;
}
/*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
** : LCD_ShowNum
** : ָλʾһ
				num:ֵ(0~4294967295);
**   : Dream
** ա  : 20101206
:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/	 
void LCD_ShowNum(uint8_t x,uint16_t y,u32 num,uint8_t len)
{         	
	uint8_t t,temp;
	uint8_t enshow=0;						   
	for(t=0;t<len;t++)
	{
		temp=(num/Num_power(10,len-t-1))%10;
		if(enshow==0&&t<(len-1))
		{
			if(temp==0)
			{
				Disp_LCDChar(x+8*t,y,' ');
				continue;
			}else enshow=1; 
		 	 
		}
	 	Disp_LCDChar(x+8*t,y,temp+0x30); 
	}
}
/*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
** : Disp_LCDLine
** : 			
** : ָλûһ
**				x1,y1:  x2,y2:յ 
**   : Dream
** ա  : 20101206
:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/
void Disp_LCDLine(uint16_t x1, uint16_t y1, uint16_t x2, uint16_t y2)
{
	uint16_t t; 
	int xerr=0,yerr=0,delta_x,delta_y,distance; 
	int incx,incy,uRow,uCol; 

	delta_x=x2-x1; 				// 
	delta_y=y2-y1; 
	uRow=x1; 
	uCol=y1; 
	if(delta_x>0)incx=1; 		//õ 
	else if(delta_x==0)incx=0;	//ֱ 
	else {incx=-1;delta_x=-delta_x;} 
	if(delta_y>0)incy=1; 
	else if(delta_y==0)incy=0;	//ˮƽ 
	else{incy=-1;delta_y=-delta_y;} 
	if( delta_x>delta_y)distance=delta_x; //ѡȡ 
	else distance=delta_y; 
	for(t=0;t<=distance+1;t++ )	// 
	{  
		Disp_LCDPoint(uRow,uCol);// 
		xerr+=delta_x ; 
		yerr+=delta_y ; 
		if(xerr>distance) 
		{ 
			xerr-=distance; 
			uRow+=incx; 
		} 
		if(yerr>distance) 
		{ 
			yerr-=distance; 
			uCol+=incy; 
		} 
	}  
}
/*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
** : LCD_DrawLine
** : ָλûһָСԲ
				(x,y):ĵ 	 r    :뾶
**   : Dream
** ա  : 20101206
:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/
void Disp_LCDCircle(uint8_t x0,uint16_t y0,uint8_t r)
{
	int a,b;
	int di;
	a=0;b=r;	  
	di=3-(r<<1);             //ж¸λõı־
	while(a<=b)
	{
		Disp_LCDPoint(x0-b,y0-a);             //3           
		Disp_LCDPoint(x0+b,y0-a);             //0           
		Disp_LCDPoint(x0-a,y0+b);             //1       
		Disp_LCDPoint(x0-b,y0-a);             //7           
		Disp_LCDPoint(x0-a,y0-b);             //2             
		Disp_LCDPoint(x0+b,y0+a);             //4               
		Disp_LCDPoint(x0+a,y0-b);             //5
		Disp_LCDPoint(x0+a,y0+b);             //6 
		Disp_LCDPoint(x0-b,y0+a);             
		a++;
		//ʹBresenham㷨Բ     
		if(di<0)di +=4*a+6;	  
		else
		{
			di+=10+4*(a-b);   
			b--;
		} 
		Disp_LCDPoint(x0+a,y0+b);
	}
} 
/*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
End:-D:-D:-D:-D:-D:-D:-D:-D:-D:-D:-D:-D:-D:-D:-D:-D:-D:-D:-D:-D
:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/
