/*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
**  ſ
**	24LC02ײ ģI2C
**  汾Rev1.0 
**  ڣ2011-6-20
**	̳www.openmcu.com	 bbs.openmcu.com
**	Աhttp://shop36995246.taobao.com/   
**  Copyright(c)@	 Dream_etd@163.com	
:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/

/* Includes ------------------------------------------------------------------*/
/* Includes ------------------------------------------------------------------*/
#include "usually.h"
#include "24LC02.h" 

extern void Delay_Ms(uint16_t time);  //ʱ
extern void Delay_Us(uint16_t time);  //ʱ

//AT24CXXַָһ
//ReadAddr:ʼĵַ  
//ֵ  :
uint8_t AT24CXX_ReadOneByte(uint16_t ReadAddr)
{				  
	uint8_t temp=0;		  	    																 
    IIC_Start();  
	if(EE_TYPE>AT24C16)
	{
		IIC_Send_Byte(0XA0);	   //д
		IIC_Wait_Ack();
		IIC_Send_Byte(ReadAddr>>8);//͸ߵַ
		IIC_Wait_Ack();		 
	}else IIC_Send_Byte(0XA0+((ReadAddr/256)<<1));   //ַ0XA0,д 	 

	IIC_Wait_Ack(); 
    IIC_Send_Byte(ReadAddr%256);   //͵͵ַ
	IIC_Wait_Ack();	    
	IIC_Start();  	 	   
	IIC_Send_Byte(0XA1);           //ģʽ			   
	IIC_Wait_Ack();	 
    temp=IIC_Read_Byte(0);		   
    IIC_Stop();//һֹͣ	    
	return temp;
}
//AT24CXXַָдһ
//WriteAddr  :дݵĿĵַ    
//DataToWrite:Ҫд
void AT24CXX_WriteOneByte(uint16_t WriteAddr,uint8_t DataToWrite)
{				   	  	    																 
    IIC_Start();  
	if(EE_TYPE>AT24C16)
	{
		IIC_Send_Byte(0XA0);	    //д
		IIC_Wait_Ack();
		IIC_Send_Byte(WriteAddr>>8);//͸ߵַ
		IIC_Wait_Ack();		 
	}else
	{
		IIC_Send_Byte(0XA0+((WriteAddr/256)<<1));   //ַ0XA0,д 
	}	 
	IIC_Wait_Ack();	   
    IIC_Send_Byte(WriteAddr%256);   //͵͵ַ
	IIC_Wait_Ack(); 	 										  		   
	IIC_Send_Byte(DataToWrite);     //ֽ							   
	IIC_Wait_Ack();  		    	   
    IIC_Stop();//һֹͣ 
	Delay_Ms(10);	 
}
//AT24CXXַָʼд볤ΪLen
//úд16bit32bit.
//WriteAddr  :ʼдĵַ  
//DataToWrite:׵ַ
//Len        :Ҫдݵĳ2,4
void AT24CXX_WriteLenByte(uint16_t WriteAddr,uint32_t DataToWrite,uint8_t Len)
{  	
	uint8_t t;
	for(t=0;t<Len;t++)
	{
		AT24CXX_WriteOneByte(WriteAddr+t,(DataToWrite>>(8*t))&0xff);
	}												    
}

//AT24CXXַָʼΪLen
//úڶ16bit32bit.
//ReadAddr   :ʼĵַ 
//ֵ     :
//Len        :Ҫݵĳ2,4
uint32_t AT24CXX_ReadLenByte(uint16_t ReadAddr,uint8_t Len)
{  	
	uint8_t t;
	uint32_t temp=0;
	for(t=0;t<Len;t++)
	{
		temp<<=8;
		temp+=AT24CXX_ReadOneByte(ReadAddr+Len-t-1); 	 				   
	}
	return temp;												    
}
//AT24CXXǷ
//24XXһַ(255)洢־.
//24Cϵ,ַҪ޸
//1:ʧ
//0:ɹ
uint8_t AT24CXX_Check(void)
{
	uint8_t temp;
	temp=AT24CXX_ReadOneByte(255);//ÿοдAT24CXX			   
	if(temp==0X55)return 0;		   
	else//ųһγʼ
	{
		AT24CXX_WriteOneByte(255,0X55);
	    temp=AT24CXX_ReadOneByte(255);	  
		if(temp==0X55)return 0;
	}
	return 1;											  
}

//AT24CXXַָʼָ
//ReadAddr :ʼĵַ 24c02Ϊ0~255
//pBuffer  :׵ַ
//NumToRead:Ҫݵĸ
void AT24CXX_Read(uint16_t ReadAddr,uint8_t *pBuffer,uint16_t NumToRead)
{
	while(NumToRead)
	{
		*pBuffer++=AT24CXX_ReadOneByte(ReadAddr++);	
		NumToRead--;
	}
}  
//AT24CXXַָʼдָ
//WriteAddr :ʼдĵַ 24c02Ϊ0~255
//pBuffer   :׵ַ
//NumToWrite:Ҫдݵĸ
void AT24CXX_Write(uint16_t WriteAddr,uint8_t *pBuffer,uint16_t NumToWrite)
{
	while(NumToWrite--)
	{
		AT24CXX_WriteOneByte(WriteAddr,*pBuffer);
		WriteAddr++;
		pBuffer++;
	}
}
void Init_IIC(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;					//һGPIOṹ
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB,ENABLE);	//ʹܸ˿ʱӣҪ

	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_6 | GPIO_Pin_7;  //LED˿ڹҽӵ61213˿
  	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;	   	//ͨ©
  	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;	   	//ö˿ٶΪ50M
  	GPIO_Init(GPIOB, &GPIO_InitStructure);				   	//˿GPIODгʼ
}
//IICʼź
void IIC_Start(void)
{
	SDA_OUT();     //sda
	IIC_SDA=1;	  	  
	IIC_SCL=1;
	Delay_Us(4);
 	IIC_SDA=0;//START:when CLK is high,DATA change form high to low 
	Delay_Us(4);
	IIC_SCL=0;//ǯסI2Cߣ׼ͻ 
}	  
//IICֹͣź
void IIC_Stop(void)
{
	SDA_OUT();//sda
	IIC_SCL=0;
	IIC_SDA=0;//STOP:when CLK is high DATA change form low to high
 	Delay_Us(4);
	IIC_SCL=1; 
	IIC_SDA=1;//I2C߽ź
	Delay_Us(4);							   	
}
//ȴӦźŵ
//ֵ1Ӧʧ
//        0Ӧɹ
uint8_t IIC_Wait_Ack(void)
{
	uint8_t ucErrTime=0;
	SDA_IN();      //SDAΪ  
	IIC_SDA=1;Delay_Us(1);	   
	IIC_SCL=1;Delay_Us(1);	 
	while(READ_SDA)
	{
		ucErrTime++;
		if(ucErrTime>250)
		{
			IIC_Stop();
			return 1;
		}
	}
	IIC_SCL=0;//ʱ0 	   
	return 0;  
} 
//ACKӦ
void IIC_Ack(void)
{
	IIC_SCL=0;
	SDA_OUT();
	IIC_SDA=0;
	Delay_Us(2);
	IIC_SCL=1;
	Delay_Us(2);
	IIC_SCL=0;
}
//ACKӦ		    
void IIC_NAck(void)
{
	IIC_SCL=0;
	SDA_OUT();
	IIC_SDA=1;
	Delay_Us(2);
	IIC_SCL=1;
	Delay_Us(2);
	IIC_SCL=0;
}					 				     
//IICһֽ
//شӻӦ
//1Ӧ
//0Ӧ			  
void IIC_Send_Byte(uint8_t txd)
{                        
    uint8_t t;   
	SDA_OUT(); 	    
    IIC_SCL=0;//ʱӿʼݴ
    for(t=0;t<8;t++)
    {              
        IIC_SDA=(txd&0x80)>>7;
        txd<<=1; 	  
		Delay_Us(2);   //TEA5767ʱǱ
		IIC_SCL=1;
		Delay_Us(2); 
		IIC_SCL=0;	
		Delay_Us(2);
    }	 
} 	    
//1ֽڣack=1ʱACKack=0nACK   
uint8_t IIC_Read_Byte(unsigned char ack)
{
	unsigned char i,receive=0;
	SDA_IN();//SDAΪ
    for(i=0;i<8;i++ )
	{
        IIC_SCL=0; 
        Delay_Us(2);
		IIC_SCL=1;
        receive<<=1;
        if(READ_SDA)receive++;   
		Delay_Us(1); 
    }					 
    if (!ack)
        IIC_NAck();//nACK
    else
        IIC_Ack(); //ACK   
    return receive;
} 
/*********************************************************************************************************
** End of File
*********************************************************************************************************/
