#ifndef LCD_DRIVE_H
#define LCD_DRIVE_H

//ͷļ
#include "stm32f10x.h"
#include "hardware.h"

#define  LCD_ID_AM  DsipV_ENABLE //ʾʽ	ı˲Ϳлʾ
							  	 //AM=0
							     //LCD_ID_AM=000ˮƽ,ˮƽʹֱַݼ
							     //LCD_ID_AM=010ˮƽ,ˮƽֱַݼ
							  	 //LCD_ID_AM=100ˮƽ,ˮƽݼֱַ
							  	 //LCD_ID_AM=110ˮƽ,ˮƽʹֱַ
							  	 //AM=1
							  	 //LCD_ID_AM=001ֱ,ˮƽʹֱַݼ
							  	 //LCD_ID_AM=011ֱ,ˮƽֱַݼ
							  	 //LCD_ID_AM=101ֱ,ˮƽݼֱַ
							  	 //LCD_ID_AM=111ֱ,ˮƽʹֱַ
							  	 //LCD_ID_AM=110: ʾ  LCD_ID_AM = 001ʾ

#define  DsipH_ENABLE  001 	  	 //ʾ
#define	 DsipV_ENABLE  110	  	 //ʾ

#if    LCD_ID_AM == DsipH_ENABLE
	#define LCD_H_MAX	320		 //ˮƽС
	#define LCD_V_MAX	240		 //ĴֱС

#elif  LCD_ID_AM == DsipV_ENABLE

	#define LCD_H_MAX	240			//ˮƽС
	#define LCD_V_MAX	320			//ĴֱС
#endif

extern uint16_t TextColor , BlackColor;

void Init_LCD(void);
void Clear_LCD(uint16_t Color);
void Write_LCDRam(uint16_t LCD_Dat);
void Write_LCDRAM_Prepare(void);
void Set_LCDCorsor(uint16_t x,uint16_t y);
uint8_t Disp_LCDChar(uint16_t x,uint16_t y,uint8_t star);
void Disp_LCDString(uint16_t x,uint16_t y,uint8_t* p);
void Disp_LCDBmp(uint16_t Xstar,uint16_t Ystar,uint16_t Xend,uint16_t Yend,uint8_t* bmp);
void LCD_ShowNum(uint8_t x,uint16_t y,u32 num,uint8_t len);
void Disp_LCDPoint(uint16_t x,uint16_t y);
void Write_LCDReg(uint16_t LCD_Reg,uint16_t LCD_Dat);
void Set_LCDWindow(uint16_t Xstar, uint16_t Ystar, uint16_t Xend, uint16_t Yend);
void Disp_LCDLine(uint16_t x1, uint16_t y1, uint16_t x2, uint16_t y2);
void Disp_LCDCircle(uint8_t x0,uint16_t y0,uint8_t r);
#endif 

